<template>
  <v-skeleton-loader :loading="!property">
    <template v-if="property">
      <v-toolbar :height="isTablet ? 90 : 120" flat class="border-bottom-think post-bar-stick">
        <v-row no-gutters align="center" justify="space-between" justify-sm="start">
          <v-col cols="12" sm="auto" class="grow text-center text-sm-left">
            <h1 class="headline font-weight-medium" v-text="property.name" />
            <span class="body-2 grey--text text--darken-2" v-text="fullAddress" />
          </v-col>
          <v-col class="shrink d-flex" order="2" order-sm="1">
            <v-bottom-sheet v-model="showBottomSheet" fullscreen style="overflow: scroll">
              <template v-slot:activator="{on}">
                <v-btn v-if="!isDesktop" :class="{'mr-3': isTablet}" icon :retain-focus-on-click="false" v-on="on">
                  <v-icon color="accent">
                    {{ mdiEmailEdit }}
                  </v-icon>
                </v-btn>
              </template>
              <v-sheet class="d-flex align-end flex-column">
                <v-btn icon color="accent" @click="showBottomSheet = false">
                  <v-icon>{{ mdiClose }}</v-icon>
                </v-btn>
                <app-connect-expert />
              </v-sheet>
            </v-bottom-sheet>
          </v-col>
          <v-col class="shrink">
            <!-- Actions -->
            <v-list-item-action style="position: relative" class="d-flex flex-row flex-nowrap">
              <v-tooltip bottom>
                <template v-slot:activator="{ on }">
                  <v-btn
                    icon
                    :color="comparison.inList ? 'accent' : comparison.canAdd ? '' : 'grey ligten-4'"
                    v-on="on"
                    @click.capture.stop="comparison.toggle(value)"
                  >
                    <v-icon>
                      {{ comparison.icon }}
                    </v-icon>
                  </v-btn>
                </template>
                <span>{{ comparison.inList ? 'Remove from' : 'Add to' }} Comparison</span>
              </v-tooltip>
              <v-tooltip bottom>
                <template v-slot:activator="{ on }">
                  <v-btn
                    icon
                    :color="favorite.inList ? 'accent' : favorite.canAdd ? '' : 'grey ligten-4'"
                    v-on="on"
                    @click.capture.stop="favorite.toggle(value)"
                  >
                    <v-icon>
                      {{ favorite.icon }}
                    </v-icon>
                  </v-btn>
                </template>
                <span>{{ favorite.inList ? 'Remove from' : 'Save to' }} Favorites</span>
              </v-tooltip>
            </v-list-item-action>
          </v-col>
          <v-col class="d-flex flex-column align-start align-sm-end shrink mt-1" order="1" order-sm="2">
            <h4 class="body-1 font-weight-medium text-no-wrap">
              {{ priceRange }}
            </h4>
            <span class="body-2 text--lighten-4">
              {{ bedRange }} Beds
            </span>
          </v-col>
        </v-row>
      </v-toolbar>

      <v-container fluid>
        <v-dialog v-model="showImages" max-width="1024">
          <v-card>
            <!-- Carousel images -->
            <v-carousel
              v-model="imagePosition"
              hide-delimiter-background
              hide-delimiters
            >
              <v-carousel-item v-for="photo in (photos ? photos : property.photos)" :key="photo.src">
                <v-img
                  :src="photo.src"
                  contain
                  height="500"
                  class="white--text"
                >
                  <template v-slot:placeholder>
                    <v-row
                      class="fill-height ma-0"
                      align="center"
                      justify="center"
                    >
                      <v-progress-circular indeterminate color="accent" />
                    </v-row>
                  </template>
                  <v-card-title
                    v-if="photo.description"
                    class="subtitle-1 py-1"
                    style="background: #00000060"
                    v-text="photo.description"
                  />
                </v-img>
              </v-carousel-item>
            </v-carousel>
          </v-card>
        </v-dialog>
        <image-gallery v-if="isDesktop" class="mb-2" :photos="property.photos" @selected="openDialog" />
        <v-carousel
          v-else
          hide-delimiter-background
          height="300"
          hide-delimiters
        >
          <v-carousel-item v-for="photo in property.photos" :key="photo.src">
            <v-img
              :src="photo.src"
              height="300"
              class="white--text"
            >
              <template v-slot:placeholder>
                <v-row
                  class="fill-height ma-0"
                  align="center"
                  justify="center"
                >
                  <v-progress-circular indeterminate color="accent" />
                </v-row>
              </template>
              <v-card-title
                v-if="photo.description"
                class="subtitle-1 py-1"
                style="background: #00000060"
                v-text="photo.description"
              />
            </v-img>
          </v-carousel-item>
        </v-carousel>
        <v-row>
          <v-col cols="12" md="4" xl="3" order="1" order-md="2">
            <app-connect-expert v-if="isDesktop" class="sticky-form" :property="property" />
          </v-col>
          <v-col cols="12" md="8" xl="9" order="2" order-md="1">
            <!-- FloorPlan -->
            <v-tabs v-model="floorTab" background-color="white" color="accent">
              <v-tab v-for="[key] in fpGrouped" :key="String(key)">
                {{ key }}
              </v-tab>
            </v-tabs>
            <v-tabs-items v-model="floorTab">
              <v-tab-item v-for="[key, floorPlans] in fpGrouped" :key="'i' + key">
                <v-simple-table>
                  <thead>
                    <tr>
                      <th class="subtitle-1 font-weight-medium black--text">
                        Beds
                      </th>
                      <th class="subtitle-1 font-weight-medium black--text">
                        Bath
                      </th>
                      <th class="subtitle-1 font-weight-medium black--text">
                        Rent
                      </th>
                      <th class="subtitle-1 font-weight-medium black--text">
                        Sq ft
                      </th>
                      <th class="subtitle-1 font-weight-medium black--text">
                        Available
                      </th>
                      <th />
                    </tr>
                  </thead>
                  <v-expand-transition>
                    <tbody>
                      <tr v-for="(fp, idx) in floorPlans.slice(0, 8)" :key="idx">
                        <td>{{ fp.bedrooms }}</td>
                        <td>{{ fp.bathrooms }}</td>
                        <td>{{ fp.price }}</td>
                        <td>{{ fp.size }}</td>
                        <td>{{ fp.availability }}</td>
                        <td>
                          <v-btn
                            color="accent"
                            small
                            depressed
                            @click="openFloorPlan(fp)"
                          >
                            <span class="text-capitalize caption">
                              View Model
                            </span>
                          </v-btn>
                        </td>
                      </tr>
                      <tr v-for="(fp, idx) in floorPlans.slice(8)" v-show="showMore" :key="8 + idx">
                        <td>{{ fp.bedrooms }}</td>
                        <td>{{ fp.bathrooms }}</td>
                        <td>{{ fp.price }}</td>
                        <td>{{ fp.size }}</td>
                        <td>{{ fp.availability }}</td>
                        <td style="width: 40px">
                          <v-btn
                            color="accent"
                            small
                            depressed
                            @click="openFloorPlan(fp)"
                          >
                            <span class="text-capitalize caption">
                              View Model
                            </span>
                          </v-btn>
                        </td>
                      </tr>
                    </tbody>
                  </v-expand-transition>
                </v-simple-table>
                <v-btn v-if="floorPlans.length > 8" text color="accent" class="my-3" @click="showMore = !showMore">
                  Show {{ showMore ? 'Less' : 'More' }}
                </v-btn>
              </v-tab-item>
            </v-tabs-items>

            <!-- Expenses -->
            <h3 v-if="Object.keys(exGrouped).length" class="mt-5 pt-0 pb-0 mb-0 headline font-weight-medium accent--text text--darken-1">
              <v-icon large color="accent darken-1">
                {{ mdiCurrencyUsd }}
              </v-icon>
              Expenses
            </h3>
            <v-row>
              <v-col v-for="(expenses, key) in exGrouped" :key="String(key)" cols="12" md="6">
                <h4 class="subtitle-1 font-weight-medium" v-text="convertFromKebab(String(key))" />
                <v-list>
                  <template v-for="expense in expenses">
                    <v-list-item :key="expense.name">
                      <v-list-item-content>
                        <v-list-item-title class="body-2" v-text="expense.name" />
                      </v-list-item-content>
                      <v-list-item-action>
                        <v-list-item-action-text class="body-2 black--text" v-text="expense.price" />
                      </v-list-item-action>
                    </v-list-item>
                    <v-divider :key="'divider -' + expense.name" />
                  </template>
                </v-list>
              </v-col>
            </v-row>

            <!-- About -->
            <h3 class="mt-5 pt-0 mb-3 headline font-weight-medium accent--text text--darken-1">
              <v-icon large color="accent darken-1">
                {{ mdiDomain }}
              </v-icon>
              Property Detail
            </h3>
            <v-list-item :class="{'flex-column': !isDesktop}">
              <v-list-item-avatar :class="{'align-self-start': isDesktop}" tile min-width="300px" width="20vw" height="100%">
                <v-img :src="property.cover" :aspect-ratio="isDesktop ? 1 : 16/9" />
              </v-list-item-avatar>

              <v-list-item-action class="ma-0 mt-1">
                <v-list-item-action-text>
                  <h4 class="title black--text">
                    {{ property.name }}
                  </h4>
                  <p class="body-2 black--text">
                    {{ property.description }}
                  </p>
                </v-list-item-action-text>
              </v-list-item-action>
            </v-list-item>

            <!-- Amenities -->
            <h3 v-if="Object.keys(amGrouped).length" class="mt-5 pt-0 mb-3 headline font-weight-medium accent--text text--darken-1">
              <v-icon large color="accent darken-1">
                {{ mdiStarCircleOutline }}
              </v-icon>
              Apartment Amenities
            </h3>
            <div class="clear">
              <div v-for="(amenities, key) in amGrouped" :key="String(key)" style="float: left; min-height: 75px" class="mt-2">
                <h4 class="subtitle-1 font-weight-medium accent--text">
                  <v-icon color="accent">
                    {{ AMENITIES_ICONS[key] }}
                  </v-icon>
                  {{ convertFromKebab(String(key)) }}
                </h4>
                <ul>
                  <li v-for="(amenity, akey) in amenities" :key="String(akey)" style="width: 250px" class="body-2">
                    {{ amenity.title }}
                  </li>
                </ul>
              </div>
            </div>

            <!-- Office Hours -->
            <h3 v-if="property.officeHours.length" class="mt-5 pt-0 mb-3 headline font-weight-medium accent--text text--darken-1">
              <v-icon large color="accent darken-1">
                {{ mdiTimerSandEmpty }}
              </v-icon>
              Office Hours
            </h3>
            <article>
              <v-row v-for="officeHour in officeHours" :key="String(officeHour.dayOfWeek)">
                <v-col cols="6">
                  {{ officeHour.dayOfWeek.join(', ') }}
                </v-col>
                <v-col cols="6" class="d-flex align-center">
                  {{ convertTo12Hours(officeHour.opens) }} - {{ convertTo12Hours(officeHour.closes) }}
                </v-col>
              </v-row>
            </article>

            <!-- Schools -->
            <h3 v-if="schGrouped.length" class="mt-5 pt-0 mb-3 headline font-weight-medium accent--text text--darken-1">
              <v-icon large color="accent darken-1">
                {{ mdiSchool }}
              </v-icon>
              Schools
            </h3>
            <v-tabs v-model="schTab" background-color="white" color="accent">
              <v-tab v-for="[key] in schGrouped" :key="key">
                {{ key }}
              </v-tab>
            </v-tabs>
            <v-tabs-items v-model="schTab">
              <v-tab-item v-for="[key, schools] in schGrouped" :key="'i' + key">
                <v-row>
                  <v-col v-for="(school, idx) in schools" :key="idx" cols="12" md="6">
                    <v-card outlined>
                      <v-card-text class="pb-0">
                        <div class="black--text">
                          {{ school.type }}
                        </div>
                        <p class="title black--text mb-2">
                          {{ school.name }}
                        </p>
                        <p class="mb-2 black--text">
                          Grades {{ school.grades }}
                        </p>
                      </v-card-text>
                      <v-card-actions>
                        <div class="black--text body-2 pl-2">
                          {{ school.students }} Students.<br>
                          {{ school.phone }}
                        </div>
                        <v-spacer />
                        <v-progress-circular
                          :value="school.rating * 10"
                          :color="'accent ' + (school.rating < 4 ? 'darken-3' : school.rating < 8 ? 'darken-1' : '')"
                          size="60"
                          width="8"
                          rotate="90"
                        >
                          <template v-if="school.rating">
                            {{ school.rating }}/10
                          </template>
                          <template v-else>
                            0
                          </template>
                        </v-progress-circular>
                      </v-card-actions>
                    </v-card>
                  </v-col>
                </v-row>
              </v-tab-item>
            </v-tabs-items>

            <h3 v-if="nearbyGrouped.length" class="mt-5 pt-0 mb-3 headline font-weight-medium accent--text text--darken-1">
              <v-icon large color="accent darken-1">
                {{ mdiRoad }}
              </v-icon>
              Nearby Transit & Points of Interest
            </h3>
            <template v-for="[key, nearbies] in nearbyGrouped">
              <h4 :key="'title' + key" class="title accent--text mt-4">
                <!-- <v-icon>{{ nearbyIcons[key] }}</v-icon> -->
                {{ convertFromKebab(key) }}
              </h4>
              <v-row :key="'content' + key" dense>
                <v-col class="font-weight-medium" cols="6">
                  Name
                </v-col>
                <v-col class="font-weight-medium" cols="3">
                  Drive
                </v-col>
                <v-col class="font-weight-medium" cols="3">
                  Distance
                </v-col>
                <template v-for="(nearby, idx) in nearbies">
                  <v-col :key="'name' + idx" class="body-2" cols="6">
                    {{ nearby.name }}
                  </v-col>
                  <v-col :key="'drive' + idx" class="body-2" cols="3">
                    {{ nearby.driving }}
                  </v-col>
                  <v-col :key="'distance' + idx" class="body-2" cols="3">
                    {{ nearby.distance }}
                  </v-col>
                </template>
              </v-row>
            </template>

            <property-near :value="property" />
          </v-col>
        </v-row>
      </v-container>
    </template>
  </v-skeleton-loader>
</template>

<script lang="ts">
import {
  mdiEmailEdit, mdiDogService, mdiRoomService, mdiFridgeOutline, mdiTableChair,
  mdiClose, mdiRoad, mdiTimerSandEmpty, mdiSchool, mdiElevatorPassenger,
  mdiStarCircleOutline, mdiGoogleNearby, mdiSecurity, mdiCalendarCheck, mdiCurrencyUsd,
  mdiInformationOutline, mdiDumbbell, mdiParking, mdiOutdoorLamp, mdiDomain
} from '@mdi/js'
import { defineComponent, ref, watch, onUnmounted, onMounted } from '@vue/composition-api'
import { Context } from '@nuxt/types'
import groupBy from 'lodash.groupby'
import sortBy from 'lodash.sortby'
import { IRentProperty, IPhoto, IFloorPlan, IOfficeHour } from 'apartments-shared'
import {
  formatFullAddress, formatRangePrice,
  formatRangeBeds, formatFloorPlan, convertFromKebab, convertTo12Hours
} from '../../utils'
import { useFavorite, useComparison } from '../../hooks/utils'
import ImageGallery from '@/components/ImageGallery.vue'
import AppConnectExpert from '@/components/AppConnectExpert.vue'
import PropertyNear from '@/components/PropertyNear.vue'

const AMENITIES_ICONS = {
  'pet-policy': mdiDogService,
  services: mdiRoomService,
  kitchen: mdiFridgeOutline,
  'living-space': mdiTableChair,
  interior: mdiElevatorPassenger,
  'unique-features': mdiGoogleNearby,
  'student-features': mdiSchool,
  security: mdiSecurity,
  'lease-length': mdiCalendarCheck,
  'property-information': mdiInformationOutline,
  'fitness-&-recreation': mdiDumbbell,
  parking: mdiParking,
  features: mdiStarCircleOutline,
  'outdoor-space': mdiOutdoorLamp
}

export default defineComponent({
  name: 'PropertyDetail',
  components: { ImageGallery, AppConnectExpert, PropertyNear },
  head () {
    return {
      title: this.property.name,
      meta: [
        { property: 'og:title', content: this.property.name },
        { hid: 'description', property: 'og:description', content: this.property.description.slice(0, 30) + '...' },
        { property: 'og:image', itemprop: 'image', content: this.property.cover },
        { property: 'og:type', content: 'website' }
      ]
    }
  },
  async asyncData ({ store, route }: Context) {
    const { id } = route.params

    const property: IRentProperty = await store.dispatch('properties/fetchItem', id)
    const floorPlans = sortBy(formatFloorPlan(property), f => !!+(f.bedrooms[0]), 'bedrooms', 'bathrooms')

    const { Studio, ...rest } = groupBy(floorPlans, 'bedrooms')
    const fpGrouped = sortBy(Object.entries(rest), 0)
    const schGrouped = Object.entries(groupBy(property.schools, 'category'))
    const nearbyGrouped = Object.entries(groupBy(property.nearby, 'category'))
    if (Studio) { fpGrouped.unshift(['Studio', Studio]) }
    fpGrouped.unshift(['All', floorPlans])
    let amGrouped = groupBy(property.amenities, 'category')
    amGrouped = Object.fromEntries(Object.entries(amGrouped).sort(([_, a], [__, b]) => a.length > b.length ? -1 : 1))
    let officeHours: IOfficeHour[] = property.officeHours
    if (officeHours.length === 1) {
      const oH = officeHours[0]
      officeHours = []
      officeHours.push({
        dayOfWeek: oH.dayOfWeek.filter(v => v !== 'Saturday' && v !== 'Sunday'),
        opens: oH.opens,
        closes: oH.closes
      })
      officeHours.push({
        dayOfWeek: ['Saturday'],
        opens: oH.opens,
        closes: oH.closes
      })
      officeHours.push({
        dayOfWeek: ['Sunday'],
        opens: oH.opens,
        closes: oH.closes
      })
    }
    const photosLength = property.photos.length
    for (let index = photosLength - 1; index > 0; index--) {
      const j = Math.floor(Math.random() * index)
      const temp = property.photos[index]
      property.photos[index] = property.photos[j]
      property.photos[j] = temp
    }
    return {
      property,
      schGrouped,
      officeHours,
      fpGrouped,
      nearbyGrouped,
      exGrouped: groupBy(property.expenses, 'type'),
      amGrouped,
      mdiEmailEdit,
      fullAddress: formatFullAddress(property),
      bedRange: formatRangeBeds(property),
      priceRange: formatRangePrice(property)
    }
  },
  setup (_, context) {
    const floorTab = ref(0)
    const schTab = ref(0)
    const showMore = ref(false)
    const { id } = context.root.$route.params

    watch(floorTab, () => (showMore.value = false))
    const showImages = ref(false)
    const imagePosition = ref(0)
    const photos = ref<IPhoto[] | null>([])
    const openDialog = (idx: number) => {
      showImages.value = true
      photos.value = null
      imagePosition.value = idx
    }
    const openFloorPlan = (fp: IFloorPlan) => {
      showImages.value = true
      photos.value = fp.photos
      imagePosition.value = 0
    }
    const pressKeyCode = ({ keyCode }: KeyboardEvent) => {
      if (!showImages.value) { return }
      if (keyCode === 39 || keyCode === 37) {
        imagePosition.value += keyCode - 38
      }
    }

    const isDesktop = ref(true)
    const isTablet = ref(false)
    onMounted(() => {
      if (process.client) {
        window.addEventListener('keyup', pressKeyCode)
      }
      isDesktop.value = context.root.$vuetify.breakpoint?.mdAndUp ?? true
      isTablet.value = context.root.$vuetify.breakpoint?.smAndUp ?? false
    })
    onUnmounted(() => {
      if (process.client) {
        window.removeEventListener('keyup', pressKeyCode)
      }
    })

    const favoriteHook = useFavorite(id)
    const comparison = useComparison(id)

    return {
      floorTab,
      isTablet,
      showImages,
      openDialog,
      imagePosition,
      isDesktop,
      photos,
      openFloorPlan,
      AMENITIES_ICONS,
      showBottomSheet: ref(false),
      ...favoriteHook,
      comparison,
      favorite: favoriteHook,
      pressKeyCode,
      mdiSchool,
      mdiClose,
      mdiStarCircleOutline,
      mdiCurrencyUsd,
      mdiRoad,
      mdiTimerSandEmpty,
      mdiDomain,
      showMore,
      nearbyIcons: {},
      schTab,
      convertFromKebab,
      convertTo12Hours
    }
  }
})
</script>

<style>
.sticky-form {
  position: sticky !important;
  top: 145px;
  /* max-height: calc(100vh - 53px);
  overflow-y: scroll;
  padding-bottom: 18vh;
  -ms-overflow-style: none; */
}
.sticky-form::-webkit-scrollbar {
  display: none;
}

.clear::after {
  clear: left;
  display: block;
  content: '';
}
</style>
